import Acquisition
import AccessControl
import OFS
from Globals import HTMLFile, MessageDialog, Persistent
import re
import string

import ActiveImage
import AI_Ext

class ActiveImages(OFS.Folder.Folder):

  """ Container class for ActiveImages """

  manage_addActiveImageForm=ActiveImage.addActiveImageForm
  manage_addActiveImage=ActiveImage.addActiveImage

  name='ActiveImages'
  id='ActiveImages'
  icon='misc_/ActiveImages/ActiveImages'
  meta_type='ActiveImages'

  all_meta_types=(
    {'name': 'ActiveImage', 'action': 'manage_addActiveImageForm'},
  )

  _properties=(
    {'id':'title','type':'string','mode':'w'},
    {'id':'groups','type':'lines','mode':'w'},
    )

  manage_options=(
    #{'label':'My Label','icon':icon,'action':'manage_main','target':'manage_main'},
    {'label':'Contents',	'action':'manage_main',			'target':'_self'},
    {'label':'Properties',	'action':'manage_propertiesForm',	'target':'_self'},
    {'label':'Validator',	'action':'manage_validator',		'target':'_self'},
    {'label':'Preview',		'action':'manage_preview',		'target':'_self'},
    {'label':'Security',	'action':'manage_access',		'target':'_self'},
    {'label':'Undo',		'action':'manage_UndoForm',		'target':'_self'},
    {'label':'Ownership',	'action':'manage_owner',		'target':'_self'},
    )

  __ac_permissions__=( # what permissions make sense for us? 
    ('View management screens', ('manage_tabs','manage_main','index_html','manage_validator','manage_preview')  ),
    ('Change permissions',      ('manage_access')  ),
    ('Change ActiveImagess',     ('')  ),
    ('View ActiveImagess',       (''), ('Anonymous','Manager')  )
    )

  def __init__(self,id,title,groups=[]):
    self.id = id
    self.title = title
    self.groups = groups

  def __str__(self,REQUEST):
    """ when called via DTML """
    return ""

  def index_html(self,REQUEST):
    """ when called via URL """
    return self.manage_main(self, REQUEST)

  jsClean=AI_Ext.jsClean
  jsSafe=AI_Ext.jsSafe
  
  manage_preview=HTMLFile('manage/preview',globals())
  manage_validator=HTMLFile('manage/validator',globals())

  js_header=HTMLFile('public/js_header',globals())
  js_newWin=HTMLFile('public/js_newWin',globals())
  js_sticky=HTMLFile('public/js_sticky',globals())
  js_footer=HTMLFile('public/js_footer',globals())
  JavaScript=HTMLFile('public/JavaScript',globals())
  
addActiveImagesForm=HTMLFile('manage/addActiveImagesForm',globals())

def addActiveImages(self,id,title,groups=[],REQUEST=None):
  """Create a ActiveImages and install it in its parent Folder
  The argument 'self' will be bound to the parent Folder.
  """
  handle=ActiveImages(id,title)
  handle.id=id
  handle.title=title
  handle.groups=groups
  self._setObject(id,handle)
  if REQUEST is not None:
    return self.manage_main(self, REQUEST)
